function [vInnovations, vVarInnovations, mStatePred, ...
    mCovStatePred] = KalmanFilter(vy, mZ, mGG, mT, mHH, mHG, va, mP)
%----------------------------------------------------------------------
cm = length(va); % n. of state elements 
cn = length(vy);
%----------------------------------------------------------------------
% Initialisation of matrices and scalars
vInnovations = NaN(1, cn);  % stores the KF innovations
vVarInnovations = NaN(1, cn); 
mStatePred = NaN(cm, cn); % stores the states predictions
mCovStatePred = NaN(cm, cn);
for i = 1:cn
	dv = vy(i) - mZ * va;      		dF = mZ * mP * mZ' + mGG;
    vInnovations(i) = dv;           vVarInnovations(i) = dF; % store resu;ts    
                                    vK = (mT * mP * mZ' + mHG) / dF;
	va = mT * va + vK * dv; 		mP = mT * mP * mT' + mHH - vK * vK' * dF ;
    mStatePred(:,i) = va;       	mCovStatePred(:,i) = diag(mP);
end
end
 